function createTable2
% CREATETABLE2 creates table 2 in the Boysen et al. paper. This function 
% is called with no inputs or outputs. It creates the file 'table2.csv' 
% which is table 2 in the paper. 


% Copyright (C) 2006  Murphy Lab
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu


setup

GLEVELS = 64;
table2 = ['Classifier output, ' char(10) 'Organism, GFP fusion, VPS32 fusion, No. of images, VCI positive, VCI negative, Classifier accuracy (%), P-value for positive vs. negative, ' char(10)];

tempvar = 1; % first two rows of table 2
[organism, fusionClasses, pval, numims, acc, confmat] = analyzeSet(GLEVELS, tempvar);
table2 = writeToTable(table2, organism, fusionClasses, pval, numims, acc, confmat);

tempvar = 2; % third and fourth rows of table 2
[organism, fusionClasses, pval, numims, acc, confmat] = analyzeSet(GLEVELS, tempvar);
table2 = writeToTable(table2, organism, fusionClasses, pval, numims, acc, confmat);

tempvar = 3; % fifth and sixth rows of table 2
[organism, fusionClasses, pval, numims, acc, confmat] = analyzeSet(GLEVELS, tempvar);
table2 = writeToTable(table2, organism, fusionClasses, pval, numims, acc, confmat);

tempvar = 4; % last two rows of table 2
[organism, fusionClasses, pval, numims, acc, confmat] = analyzeSet(GLEVELS, tempvar);
table2 = writeToTable(table2, organism, fusionClasses, pval, numims, acc, confmat);

fid = fopen('table2.csv','w');
fwrite(fid, table2);
fclose(fid);

return


function table2 = writeToTable( table2, organism, fusionClasses, pval, numims, acc, confmat)

table2 = [table2 organism ', ' fusionClasses{1} ', ' fusionClasses{2} ', ' ...
    num2str(numims(1)) ', ' num2str( confmat(1,1)) ', ' num2str(confmat(1,2)) ', ' num2str(acc) ', ' num2str(pval(1,2)) ', ' char(10) ...
    ',,, ' num2str(numims(2)) ', ' num2str( confmat(2,1)) ', ' num2str(confmat(2,2)) ',,, ' char(10)];
