function calculateFeatures(readpath, writepaths, featsets, GLEVELS, NLEVELS)

% Copyright (C) 2006  Murphy Lab
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu

writepaths = writepaths(1:2);
idx = findstr(writepaths{1},'overlap');
writepaths{1}(idx:idx+length('overlap')-1) = [];
writepaths{1} = [writepaths{1}(1:idx-1) 'protfeat' writepaths{1}(idx:end)];

idx = findstr(writepaths{2},'texture');
writepaths{2}(idx:idx+length('texture')-1) = [];
writepaths{2} = [writepaths{2}(1:idx-1) 'dnafeat' writepaths{2}(idx:end)];


idx = ones( length(writepaths),1);
for i=1:length(writepaths)
    idx(i) = ~exist( writepaths{i},'file');
end

writepaths = writepaths( find(idx));
featsets = featsets( find(idx));

if ~sum(idx)
    return
end

prp = readpath;
prp((prp == '/') | (prp == '.')) = '_';
pr = ['tmp/calculatingFeatures_' prp '.txt'];
if ~exist( pr,'file')
    fr = fopen( pr, 'w');
else
    return
end

% Load image
I = imread( readpath);

% NEW CODE
J = nmfunmix( I);

GLEVELS = 32;
dbtype = 'db4';
NLEVELS = 10;

ofeat = features_nuclearOverlap( J(:,:,2), J(:,:,1));
tfeat = features_texture( J(:,:,2), GLEVELS);
wfeat = features_textureMR( J(:,:,2), GLEVELS,dbtype, NLEVELS);
protfeat = [ofeat tfeat wfeat];

tfeat = features_texture( J(:,:,1), GLEVELS);
wfeat = features_textureMR( J(:,:,1), GLEVELS,dbtype, NLEVELS);
dnafeat = [tfeat wfeat];

save( writepaths{1}, 'protfeat');
save( writepaths{2}, 'dnafeat');

fclose(fr);
delete(pr);





% % return
% % % Set initial parameters
% % inputs.correction = 'yes';
% % 
% % % Calculate filter features
% % idx = find( strcmp( 'filter',featsets));
% % if ~isempty(idx)
% %     inputs.chroma = 3;
% %     J = linunmix( I, inputs);
% %     ffeats = features_filter( J(:,:,3));
% %     save( writepaths{idx}, 'ffeats');
% % end
% % 
% % % Set parameters again
% % inputs.chroma = 2;
% % 
% % % Perform linear unmixing for all subsequent steps
% % J = linunmix(I, inputs);
% % prot = J(:,:,2);
% % dna = J(:,:,1);
% % clear J
% % 
% % % Calculate nuclear overlap features
% % idx = find( strcmp( 'overlap',featsets));
% % if ~isempty(idx)
% %     ofeats = features_nuclearOverlap( prot, dna);
% %     save( writepaths{idx}, 'ofeats');
% % end
% % 
% % % Calculate texture features
% % idx = find( strcmp( 'texture',featsets));
% % if ~isempty(idx)
% %     tfeats = features_texture( prot, GLEVELS);
% %     save( writepaths{idx}, 'tfeats');
% % end
% % 
% % % Calculate multiresolution texture features
% % idx = strmatch( 'MR_db', featsets);
% % for i=1:length(idx)
% %     dbtype  = featsets{idx(i)}(4:end);
% %     wfeats = features_textureMR( prot, GLEVELS, dbtype, NLEVELS);
% %     save( writepaths{idx(i)}, 'wfeats');
% % end
% % 
% % fclose(fr);
% % delete(pr);
% % 
