function wfeat = features_textureMR( prot, GLEVELS,dbtype, NLEVELS)

% Copyright (C) 2006  Murphy Lab
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu

prot = single(prot);

[C,S] = wavedec2(prot,NLEVELS,dbtype);

FPL = 27;
wfeat = zeros( 1, FPL*NLEVELS);
for k = 0 : NLEVELS-1
    [chd,cvd,cdd] = detcoef2('all',C,S,(NLEVELS-k));
    A = [chd cvd cdd];
    A = A - min(A(:));
    A = uint8(round(GLEVELS*A/max(A(:))));
    
    feat = ml_texture( A);
    feat = [mean(feat(1:13,[1 3]),2); mean(feat(1:13,[2 4]),2)]';
    
    wfeat(1,(FPL*k)+1:(k+1)*FPL) = [...
        feat sqrt(sum(sum(A.^2))) ];
end

return
% 
% 
%     keyboard;
%     A = chd - min(chd(:));
%     A = uint8(round(GLEVELS*A/max(A(:))));
%     hfeat = ml_texture( A);
%     hfeat = [mean(hfeat(1:13,[1 3]),2); mean(hfeat(1:13,[2 4]),2)]';
% 
%     A = cvd - min(cvd(:));
%     A = uint8(round(GLEVELS*A/max(A(:))));
%     vfeat = ml_texture( A);
%     vfeat = [mean(vfeat(1:13,[1 3]),2); mean(vfeat(1:13,[2 4]),2)]';
% 
%     A = cdd - min(cdd(:));
%     A = uint8(round(GLEVELS*A/max(A(:))));
%     dfeat = ml_texture( A);
%     dfeat = [mean(dfeat(1:13,[1 3]),2); mean(dfeat(1:13,[2 4]),2)]';
% 
%     wfeat(1,(FPL*k)+1:(k+1)*FPL) = [...
%         hfeat vfeat dfeat ...
%         sqrt(sum(sum(chd.^2))) ...
%         sqrt(sum(sum(cvd.^2))) ...
%         sqrt(sum(sum(cdd.^2))) ...
%     ];
% end
% 
% return
% 
