function I = preprocessVesicle( I, GLEVELS, CLASSMAX)
% function I = preprocessVesicle( I, GLEVELS)

% Copyright (C) 2006  Murphy Lab
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu

%% PREPROCESSING

if ~exist( 'GLEVELS','var')
    GLEVELS = 32;  % Must be greater than 2
end

% BG subtraction, most-common pixel
[c b] = imhist( I);
[a ind] = max(c);
I=I-b(ind);

% Contrast stretching (upper bound to specified graylevels)
% sc = (GLEVELS-1) / double(CLASSMAX);
sc = (GLEVELS-1) / double(max(I(:)));
I = uint8(round(sc*double(I)));
