function feat = calcVesicleFeats( I, GLEVELS, CLASSMAX)
% function feat = calcVesicleFeats( I, GLEVELS)
% FEAT = CALCFEATS( I, GLEVELS)

% Copyright (C) 2006  Murphy Lab
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu


%% INPUT HANDLING
% Input initialization

I = preprocessVesicle( I, GLEVELS, CLASSMAX);
% I = preprocessVesicle( I, GLEVELS);

options.GLEVELS = GLEVELS;
options.ISRAWIM = 'no';

Nrows = 1;
Ncols = 1;
size_I = size(I);
coords = gettilecoords2d(Nrows,Ncols,size_I);

feat =zeros(size(coords,1),26+GLEVELS-2);
for j=1:size(coords,1)
    [J,pt] = gettile(I,floor(size_I(2)/Ncols/2),floor(size_I(1)/Nrows/2),coords(j,:));
        
    tfeat = ml_texture(J);
    tfeat = [mean(tfeat(1:13,[1 3]),2); mean(tfeat(1:13,[2 4]),2)]';
    hfeat = ml_histfeatures( J, options);

    feat(j,:) = [tfeat hfeat];
end

% feat = feat';
% feat = feat(:);
% feat = feat';

return
